package kr.co.vividnext.sodalive.explorer.profile.creatorCommunity

import com.querydsl.core.annotations.QueryProjection
import kr.co.vividnext.sodalive.explorer.profile.creatorCommunity.comment.GetCommunityPostCommentListItem
import java.time.LocalDateTime

data class SelectCommunityPostResponse @QueryProjection constructor(
    val id: Long,
    val creatorId: Long,
    val creatorNickname: String,
    val creatorProfileUrl: String,
    val imagePath: String?,
    val content: String,
    val date: LocalDateTime,
    val isCommentAvailable: Boolean,
    val price: Int
) {
    fun toCommunityPostListResponse(
        imageHost: String,
        date: String,
        isLike: Boolean,
        existOrdered: Boolean,
        likeCount: Int,
        commentCount: Int,
        firstComment: GetCommunityPostCommentListItem?
    ): GetCommunityPostListResponse {
        return GetCommunityPostListResponse(
            postId = id,
            creatorId = creatorId,
            creatorNickname = creatorNickname,
            creatorProfileUrl = "$imageHost/$creatorProfileUrl",
            imageUrl = if (imagePath != null) {
                "$imageHost/$imagePath"
            } else {
                null
            },
            content = content,
            price = price,
            date = date,
            isCommentAvailable = isCommentAvailable,
            isAdult = false,
            isLike = isLike,
            existOrdered = existOrdered,
            likeCount = likeCount,
            commentCount = commentCount,
            firstComment = firstComment
        )
    }
}
